
######### Supplemental material model: preparation PCA #########

####principal components analysis####

#### packages ####
library(raster)
library(RStoolbox)
library(compositions)
library(ranger)
library(maptools)
library(rgdal)

#### setting paths ####
path2pca = "path/PCA/reduced/"
path2points = "path/gvdata/"
path2stack = "path/final_stack"
way = "path/predictors/"
setwd(way)
obj= dir()

#### first make sure all your raster have identical extent, coordinate system and number of pixels####

####PCA creation####
#You dont need to compress all your predictor variables, just the appropriate ones#

#### PCA_group1 ####
setwd(paste( way, sep ="") )
i= #folder location number of your selected group
dir()[i]
system.time( 
  assign(paste("PCA_", strsplit(dir()[i], "[.]")[[1]][1], sep="") , rasterPCA( stack(dir()[i]), spca= TRUE) ) 
)

writeRaster(PCA_group1$map, paste(path2pca, "pca_", strsplit(dir()[i], "[.]")[[1]][1], ".tif", sep=""), overwrite=T, COMPRESS=LZW)
save.image(paste(path2pca, "pca_", strsplit(dir()[i], "[.]")[[1]][1], ".RData", sep="") )
rm(PCA_group1)
gc() 


#### extracting PCAs with 95% threshold ####

load(paste(path2pca, "pca_group1.RData", sep=""))
summary(PCA_group1$model) # use first 2
tmp= stack(paste(path2pca, "pca_group1.tif", sep=""))
pca_group1_red= dropLayer(tmp, 3:7)
names(pca_group1_red)
writeRaster(pca_group1_red, paste(path2pca, "pca_group1_red.tif"), overwrite=T, COMPRESS=LZW)
rm(PCA_group1, pca_group1_red, tmp, i); gc()

