######### Supplemental material: multinomial modelling #########

####first run "2. model_peparation" script####

#version number, change!
v=1


#####Optimize gbm input parameters####
gbmGrid <- expand.grid(.n.trees = c(1000, 1500),
                       .interaction.depth = c(10,15),
                       .shrinkage = c(0.01,0.005),
                       .n.minobsinnode = c(3))

#### paralell processing####

#doParallel
nCPUs <- detectCores()-1
library(doParallel)
cl <- makeCluster(nCPUs)
registerDoParallel(cl)

####Develop gbm model####
rm(gbm.mod) #remove any legacy model loaded by mistake
gbm.mod <- train(TrainData, factor(TrainClasses), method = "gbm", verbose = FALSE, distribution="multinomial", tuneGrid=gbmGrid, metric="Accuracy", maximize=TRUE)

save("gbm.mod", file = paste("path",colnames(df)[i],"_version_",v,".RData", sep="")) #save model to RData file
rm("gbm.mod") #remove model from workspace
load(paste("path",colnames(df)[i],"_version_",v,".RData", sep="")) #load model back into workspace

print(gbm.mod)
print(summary(gbm.mod))
print(ptm <- proc.time())

#### spatial prediction ####
rasters <- env

#### Create raster predictions #### 

rast.pred <- predict(rasters, gbm.mod, progress="text", type="raw")

stopCluster(cl)

####Export predictions to geotiff file for use as layer in GIS####

writeRaster(rast.pred, paste("path",colnames(df)[i],"_version_",v,".tif", sep=""), overwrite=FALSE, COMPRESS=LZW)
