######### Supplemental material: continuous compositional modelling #########
#this is an alternative route to model mainly substrate componenets and make the outputs always sum to 100%. Hoever, individual models that are adjusted after the modelling work well to according to our study

####first run "2. model_peparation" script####



#### load additional packages ####
library(compositions)

#version number, change!
v=1

#### compositional isometric log ratio transformation ####
names(df[,c(XX:XX)]) 
df.belowdet <- df[,c(xx:xx)] #select your compositions, the order matters for the exact model output and which class will be the n-1 degree of freedom

df.belowdet[df.belowdet == 0] <- 0.001 #change all 0 to have a small probability instead of 0

comp <- acomp(df.belowdet) # below detection limit
colnames(comp)
#sbp<- matrix(c(-1,0,0,0,1,1,1,1,1,1,1,-1,1,1,-1,0,1,-1,0,0), nrow=4) # the sequential binary partition for 5 classes

sbp<- matrix(c(-1,0,0,0,0,0 ,1,1,1,1,1,1 ,1,1,1,1,1,-1 ,1,1,1,1,-1,0 ,1,1,1,-1,0,0 ,1,1,-1,0,0,0 ,1,-1,0,0,0,0), nrow=6) # the sequential binary partition for 7 classes

colnames(sbp) <- colnames(comp)

psi <- gsi.buildilrBase(t(sbp)) # the orthogonal matrix

CoDaDendrogram(comp, V=psi, type = "boxplot")

bal <- ilr(comp, V=psi) #balance function


#### brt model forloop ####

for (i in c(1:6)) {

# histograms
plot(hist(bal[,i]))

#quantile plot
qqnorm((bal[,i]))
qqline(bal[,i], col = "red") 

TrainClasses <- bal[,i]

####paralell processing setup###
nCPUs <- detectCores()-1
library(doParallel)
cl <- makeCluster(nCPUs)
registerDoParallel(cl)


####Optimize gbm input parameters####

gbmGrid <- expand.grid(.n.trees = c(1000, 1500),
                       .interaction.depth = c(10,15),
                       .shrinkage = c(0.01,0.005),
                       .n.minobsinnode = c(3))


TrainClasses <- as.numeric(TrainClasses)

####Develop gbm model####
rm(gbm.mod) #remove any legacy model loaded by mistake

gbm.mod <- train(TrainData, TrainClasses, method = "gbm", verbose = FALSE, distribution="gaussian", tuneGrid=gbmGrid, metric="RMSE", maximize=FALSE)

save("gbm.mod", file = paste("path/compositional/","transformed_substrate_composition_",i,"_version_",v,".RData", sep="")) #save model to RData file
rm("gbm.mod") #remove model from workspace
load(paste("path/compositional/","transformed_substrate_composition_",i,"_version_",v,".RData", sep="")) #load model back into workspace

print(gbm.mod)
print(summary(gbm.mod))

#### spatial prediction ####
rasters <- env

#### Create raster predictions #### 

#apply gbm.mod across space
rast.pred <- predict(rasters, gbm.mod, progress="text", type="raw")

stopCluster(cl)

#Export predictions to geotiff file for use as layer in GIS

writeRaster(rast.pred, paste("path/compositional/", "comp_",i,"_version_",v,".tif", sep=""), overwrite=TRUE, COMPRESS=LZW)

}

####end foreloop####

#### inverse transformation####
#load untransformed raster objects
rast.pred1 <- raster(paste("path/compositional/comp_",1,"_version_",v,".tif", sep=""))
rast.pred2 <- raster(paste("path/compositional/comp_",2,"_version_",v,".tif", sep=""))
rast.pred3 <- raster(paste("path/compositional/comp_",3,"_version_",v,".tif", sep=""))
rast.pred4 <- raster(paste("path/compositional/comp_",4,"_version_",v,".tif", sep=""))
rast.pred5 <- raster(paste("path/compositional/comp_",5,"_version_",v,".tif", sep=""))
rast.pred6 <- raster(paste("path/compositional/comp_",6,"_version_",v,".tif", sep=""))

#### backtransform model outputs####
rast.pred.df <- data.frame(as.data.frame(rast.pred1), as.data.frame(rast.pred2), as.data.frame(rast.pred3), as.data.frame(rast.pred4), as.data.frame(rast.pred5), as.data.frame(rast.pred6))

str(rast.pred.df)

rast.pred.bt <- as.data.frame(ilrInv(rast.pred.df, V=psi))

####create rasters from the backtransformed outputs####
 
coordinates(rast.pred1)

prediction<- cbind(coordinates(rast.pred1), rast.pred.bt)

names(prediction)

coordinates(prediction)<- ~x+y
proj4string(prediction) <- CRS("+proj=utm +zone=33 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs") # # Used projection is Sweref99 TM (UTM33N)  # EPSG:3006
gridded(prediction)<- T
prediction<- stack(prediction)

#### write backtransformed compositions to geotif####

for (i in 1:6) {
writeRaster(raster(prediction, i), filename=paste("path/compositional/", names(raster(prediction, i)), "_version_",v,".tif", sep=""), overwrite=T, COMPRESS=LZW)
}

